#!/usr/bin/python
import numpy as np
import math
import matplotlib
from matplotlib import pyplot as plt
import matplotlib.cm as cm
import skrf as rf

freq = rf.Frequency(0.1,50,500,'ghz')
freqs = np.linspace(0.1,50,500)
cpw = rf.media.CPW(freq, w=24e-6, s=13e-6, ep_r=11.42, t=200e-9, rho=2.44e-8)

props = cpw.gamma()

Z0s = cpw.Z0()

fig1 = plt.figure(1)
ax11  = fig1.add_subplot(121)
ax12 = ax11.twinx()
ax12.plot(freqs,np.real(props),'-r')
ax11.plot(freqs,np.imag(props),'-b')
ax21 = fig1.add_subplot(122)
ax21.plot(freqs,np.real(Z0s),'-r')
ax21.plot(freqs,np.imag(Z0s),'-b')

plt.show()