#!/usr/bin/python
import numpy as np
import math
import matplotlib
from matplotlib import pyplot as plt
import pylab
import matplotlib.gridspec as gridspec
import TRL_optimize
import TRL_plot

#Code to plot output of Simulated Annealing Optimization

def TRLoptplot(lineparams,optarray,optfilename):

	verbose = 0
	
	#parse parameter array
	paramnames = []
	new_paramlist = []
	deltalist = []
	ranges = []
	for i in range(0,len(lineparams)):
		paramnames.append(lineparams[i][0])
		new_paramlist.append(lineparams[i][1])
		deltalist.append(lineparams[i][2])
		ranges.append(lineparams[i][3])
		
	numplots = len(lineparams)+1
	
	if verbose == 1:
		print(paramnames)
		print(new_paramlist)
		print(deltalist)
		print(ranges)
	
	#import data from file
	fin = open(optfilename,'r')
	recparamarray = []
	recoptimizearray = []
	maxoptimizearray = []
	recstepnumarray = []
	maxstepnumarray = []
	stepnum = 0
	for line in fin:
		datavector = line.split(" ")
		recstepnumarray.append(stepnum)
		paramdata = []
		for i in range(0,len(datavector) - 1):
			paramdata.append(float(datavector[i]))
		recparamarray.append(paramdata)
		recoptimizearray.append(float(datavector[len(datavector)-1]))
		if stepnum == 0:
			maxstepnumarray.append(stepnum)
			maxoptimizearray.append(float(datavector[len(datavector)-1]))
		elif float(datavector[len(datavector)-1]) >= maxoptimizearray[len(maxoptimizearray)-1]:
			maxstepnumarray.append(stepnum)
			maxoptimizearray.append(float(datavector[len(datavector)-1]))
		stepnum = stepnum + 1
	
	fin.close()
	ymax = 5
	
	t = np.arange(len(recoptimizearray))
	fig1 = plt.figure(1)
	
	size_x = int(np.sqrt(numplots))
	if size_x*size_x == numplots:
		size_y = size_x
	elif size_x*(size_x+1) >= numplots:
		size_y = size_x + 1
	else:
		size_x = size_x + 1
		size_y = size_x
		
	print(numplots)
	print(size_x)
	print(size_y)
		
	gs = gridspec.GridSpec(size_y, size_x)
	
	#first plot of time evolution of SA run
	ax11=fig1.add_subplot(gs[0,0])
	ax11.plot(recstepnumarray,recoptimizearray,'-r')
	ax11.plot(maxstepnumarray,maxoptimizearray,'-b')
	ax11.set_xlabel('Step Number')
	ax11.set_ylabel(r'$1/\sigma^2_\alpha + 1/\sigma^2_\beta$')
	
	for plotnum in range(0,len(lineparams)):
		num = plotnum + 2
		xpos = num-int((num-1)/size_x)*size_x-1
		ypos = int((num-1)/size_x)
		#print 'total plts = ' + str(totalplots) + ' in ' + str(size_x) + 'x' + str(size_y) + ' at ' + str(xpos) + ',' + str(ypos)
		curraxes=fig1.add_subplot(gs[ypos,xpos])
		curraxes.scatter(np.array(recparamarray)[:,plotnum],recoptimizearray,c=t,s=12,edgecolor='none')
		curraxes.set_xlabel(paramnames[plotnum])
		curraxes.set_ylabel(r'$1/\sigma^2_\alpha + 1/\sigma^2_\beta$')
		curraxes.set_xlim(ranges[plotnum])
		#curraxes.set_ylim((0,ymax))
		#fig1.subplots_adjust(left=0.16)
		#pylab.draw()
	
	plt.show()